package ink.wgink.interfaces.group;

import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.dtos.ZTreeDTO;
import ink.wgink.pojo.dtos.group.GroupDTO;
import ink.wgink.pojo.pos.GroupPO;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * When you feel like quitting. Think about why you started
 * 当你想要放弃的时候，想想当初你为何开始
 *
 * @ClassName: IGroupService
 * @Description: 组
 * @Author: WangGeng
 * @Date: 2021/1/24 12:55
 * @Version: 1.0
 **/
public interface IGroupBaseService {

    /**
     * 全部组JSON列表
     *
     * @param groupParentId
     * @return
     */
    List<GroupDTO> listAllByParentId(String groupParentId);

    /**
     * 组列表，递归获取全部内容
     *
     * @param params
     * @return
     */
    List<GroupDTO> listAll(Map<String, Object> params);

    /**
     * 组详情
     *
     * @param params
     * @return
     */
    GroupDTO get(Map<String, Object> params);

    /**
     * 组详情
     *
     * @param groupId
     * @return
     */
    GroupDTO get(String groupId);

    /**
     * 组zTree列表
     *
     * @param params
     * @return
     */
    List<ZTreeDTO> listZTree(Map<String, Object> params);

    /**
     * 组EasyUI列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<GroupDTO>> listPage(ListPage page);

    /**
     * 组列表
     *
     * @param params
     * @return
     */
    List<GroupDTO> list(Map<String, Object> params);

    /**
     * 用户组列表
     *
     * @param groupIds 用户ID列表
     * @return
     */
    List<GroupDTO> list(List<String> groupIds);

    /**
     * 组列表
     *
     * @param params
     * @return
     */
    List<GroupPO> listPO(Map<String, Object> params);

    /**
     * 组列表
     *
     * @param groupIds
     * @return
     */
    List<GroupPO> listPO(List<String> groupIds);
}
